clear; clc; close all;

load('Gaussian_Schell_Sim_Results.mat');

figure;
set(gcf,'position',[520 420 384 384]);

subplot(321);
imagesc(xs(1,:)*100,ys(:,1)*100,abs(U_ver)); axis image; h = colorbar;
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$y \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(h,'ticklabelinterpreter','latex');
set(gca,'position',[0.0857+0.007 0.7452 0.25 0.25]);
text(1.3229,1.8437,'$\mbox{(a)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(322);
imagesc(xs(1,:)*100,ys(:,1)*100,angle(U_ver)); axis image; h = colorbar;
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$y \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(h,'ticklabelinterpreter','latex');
set(gca,'position',[0.612+0.007 0.7452 0.25 0.25]);
text(1.2187,1.8437,'$\mbox{(b)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(323);
imagesc(xs(1,:)*100,ys(:,1)*100,abs(U)); axis image; h = colorbar;
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$y \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(h,'ticklabelinterpreter','latex');
set(gca,'position',[0.0857+0.007 0.3961 0.25 0.25]);
text(1.375,1.8438,'$\mbox{(c)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(324);
imagesc(xs(1,:)*100,ys(:,1)*100,angle(U)); axis image; h = colorbar;
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$y \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(h,'ticklabelinterpreter','latex');
set(gca,'position',[0.612+0.007 0.3961 0.25 0.25]);
text(1.2708,1.8438,'$\mbox{(d)}$','interpreter','latex','backgroundcolor',[1 1 1]);

subplot(3,2,5);
bin_c = diff(U_binedges)/2 + U_binedges(1:end-1);
inds = 1:10:length(bin_c);
p1 = plot(bin_c,normpdf(bin_c,0,1/sqrt(2)));
hold on;
h1 = histogram('BinEdges',U_binedges,'BinCounts',Ur_counts_ver,'normalization','pdf','visible','off');
p2 = plot(bin_c(inds),h1.Values(inds),'o');
h2 = histogram('BinEdges',U_binedges,'BinCounts',Ur_counts,'normalization','pdf','visible','off');
p3 = plot(bin_c(inds),h2.Values(inds),'s');
set(gca,'ticklabelinterpreter','latex');
ylabel('$p\left[\mbox{Re}\left(U\right)\right]$','interpreter','latex');
xlabel('$\mbox{Re}\left(U\right)$','interpreter','latex');
axis tight; grid on;
ylim([0 max([normpdf(bin_c,0,1/sqrt(2)) h1.Values h2.Values])]);
set(gca,'position',[0.0911 0.0755 0.35 0.2216]);
% h = legend([p1 p2 p3],{'$\mbox{Theory}$','$\mbox{CS}$','$S,i$'});
% set(h,'interpreter','latex');
text(-0.3639,0.1102,'$\mbox{(e)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(3,2,6);
bin_c = diff(U_binedges)/2 + U_binedges(1:end-1);
inds = 1:10:length(bin_c);
p1 = plot(bin_c,normpdf(bin_c,0,1/sqrt(2)));
hold on;
h1 = histogram('BinEdges',U_binedges,'BinCounts',Ui_counts_ver,'normalization','pdf','visible','off');
p2 = plot(bin_c(inds),h1.Values(inds),'o');
h2 = histogram('BinEdges',U_binedges,'BinCounts',Ui_counts,'normalization','pdf','visible','off');
p3 = plot(bin_c(inds),h2.Values(inds),'s');
set(gca,'ticklabelinterpreter','latex');
ylabel('$p\left[\mbox{Im}\left(U\right)\right]$','interpreter','latex');
xlabel('$\mbox{Im}\left(U\right)$','interpreter','latex');
axis tight; grid on;
ylim([0 max([normpdf(bin_c,0,1/sqrt(2)) h1.Values h2.Values])]);
set(gca,'position',[0.5572 0.0755 0.35 0.2216]);
h = legend([p1 p2 p3],{'$\mbox{Theory}$','$\mbox{CS}$','$S,i$'});
set(h,'interpreter','latex','position',[0.3766 0.2657 0.1691 0.103]);
text(-0.3639,0.1102,'$\mbox{(f)}$','interpreter','latex','backgroundcolor',[1 1 1]);

print(gcf,'GSM_fields.eps','-depsc','-painters');

%% 

figure;
set(gcf,'position',[520 420 480 384]);

subplot(331);
imagesc(xs(1,:)*100,ys(:,1)*100,real(Wx1x2_thy)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.0446 0.764 0.225 0.225]);
text(-2.1828,1.7288,'$\mbox{(a)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(332);
imagesc(xs(1,:)*100,ys(:,1)*100,real(Wx1x2_ver)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.3765 0.764 0.225 0.225]);
text(-2.1721,1.7288,'$\mbox{(b)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(333);
imagesc(xs(1,:)*100,ys(:,1)*100,real(Wx1x2)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.7125 0.764 0.225 0.225]);
text(-2.1882,1.7288,'$\mbox{(c)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(334);
imagesc(xs(1,:)*100,ys(:,1)*100,imag(Wx1x2_thy)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.0446 0.4383 0.225 0.225]);
text(1.0984,1.7288,'$\mbox{(d)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(335);
imagesc(xs(1,:)*100,ys(:,1)*100,imag(Wx1x2_ver)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.3765 0.4383 0.225 0.225]);
text(1.2708,1.7288,'$\mbox{(e)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(336);
imagesc(xs(1,:)*100,ys(:,1)*100,imag(Wx1x2)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.7125 0.4383 0.225 0.225]);
text(1.2708,1.7288,'$\mbox{(f)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(3,3,7);
inds = 1:10:size(xs,2);
temp = diag(real(Wx1x2_thy));
plot(xs(1,:)*100,temp); 
hold on;
temp = diag(real(Wx1x2_ver));
plot(xs(1,inds)*100,temp(inds),'o','color',[0.93 0.69 0.13]); 
temp = diag(real(Wx1x2));
plot(xs(1,inds)*100,temp(inds),'s','color',[0.47 0.69 0.19]); 
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$\langle I\left(x,0\right)\rangle$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
axis tight; grid on;
h = legend('$\mbox{Theory}$','$\mbox{CS}$','$S,i$');
set(h,'interpreter','latex','position',[0.3182 0.2521 0.1691 0.103]);
set(gca,'position',[0.0654 0.0755 0.3867 0.2632]);
text(-2.046,0.7876,'$\mbox{(g)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(3,3,9);
inds = 1:3:size(xs,2);
temp = real(Wx1x2_thy(xs==-ys));
xs_plot = xs(xs==-ys);
plot(xs_plot*100,temp); 
hold on;
temp = real(Wx1x2_ver(xs==-ys));
plot(xs_plot(inds)*100,temp(inds),'o','color',[0.93 0.69 0.13]); 
temp = real(Wx1x2(xs==-ys));
plot(xs_plot(inds)*100,temp(inds),'s','color',[0.47 0.69 0.19]); 
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$\mbox{Re}\left[W\left(x,0,-x,0\right)\right]$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
axis tight; grid on;
% h = legend('$\mbox{Theory}$','$\mbox{CS}$','$S,i$');
% set(h,'interpreter','latex');
set(gca,'position',[0.5592 0.0755 0.3867 0.2632]);
text(0.2925,0.7985,'$\mbox{(h)}$','interpreter','latex','backgroundcolor',[1 1 1]);
xlim([-0.5 0.5]);

print(gcf,'GSM_W.eps','-depsc','-painters');

%%
figure;
set(gcf,'position',[520 420 480 384]);
subplot(331);
imagesc(xs(1,:)*100,ys(:,1)*100,BI_thy); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.0446 0.764 0.225 0.225]);
text(-2.1828,1.7288,'$\mbox{(a)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(332);
imagesc(xs(1,:)*100,ys(:,1)*100,BI_ver); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.3765 0.764 0.225 0.225]);
text(-2.1721,1.7288,'$\mbox{(b)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(333);
imagesc(xs(1,:)*100,ys(:,1)*100,BI); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.7125 0.764 0.225 0.225]);
text(-2.1882,1.7288,'$\mbox{(c)}$','interpreter','latex','backgroundcolor',[1 1 1]);

subplot(3,3,4);
inds = 1:10:size(xs,2);
temp = diag(BI_thy);
plot(xs(1,:)*100,temp); 
hold on;
temp = diag(BI_ver);
plot(xs(1,inds)*100,temp(inds),'o','color',[0.93 0.69 0.13]); 
temp = diag(BI);
plot(xs(1,inds)*100,temp(inds),'s','color',[0.47 0.69 0.19]); 
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$B_I\left(x,0,x,0\right)$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
axis tight; grid on;
% h = legend('$\mbox{Theory}$','$\mbox{CS}$','$S,i$');
% set(h,'interpreter','latex','position',[0.3349 0.2495 0.1418 0.103]);
set(gca,'position',[0.0654 0.401 0.3867 0.2632]);
text(-1.9119,0.8787,'$\mbox{(d)}$','interpreter','latex','backgroundcolor',[1 1 1]);
ylim([0.8 1.2]);
subplot(3,3,6);
inds = 1:2:size(xs,2);
temp = BI_thy(xs==-ys);
xs_plot = xs(xs==-ys);
plot(xs_plot*100,temp); 
hold on;
temp = BI_ver(xs==-ys);
plot(xs_plot(inds)*100,temp(inds),'o','color',[0.93 0.69 0.13]); 
temp = BI(xs==-ys);
plot(xs_plot(inds)*100,temp(inds),'s','color',[0.47 0.69 0.19]); 
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$B_I\left(x,0,-x,0\right)$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
axis tight; grid on;
% h = legend('$\mbox{Theory}$','$\mbox{CS}$','$S,i$');
% set(h,'interpreter','latex','position',[0.2379 0.2729 0.1691 0.103]);
set(gca,'position',[0.5592 0.401 0.3867 0.2632]);
text(0.2925,0.7985,'$\mbox{(e)}$','interpreter','latex','backgroundcolor',[1 1 1]);
xlim([-0.5 0.5]);

subplot(3,3,[7 9]);
bin_c = diff(iI_binedges)/2 + iI_binedges(1:end-1);
inds = 1:5:length(bin_c);
p1 = plot(bin_c,exppdf(bin_c,1));
hold on;
h1 = histogram('BinEdges',iI_binedges,'BinCounts',iI_counts_ver,'normalization','pdf','visible','off');
p2 = plot(bin_c(inds),h1.Values(inds),'o');
h2 = histogram('BinEdges',iI_binedges,'BinCounts',iI_counts,'normalization','pdf','visible','off');
p3 = plot(bin_c(inds),h2.Values(inds),'s');
set(gca,'ticklabelinterpreter','latex');
ylabel('$p\left(I\right)$','interpreter','latex');
xlabel('$I$','interpreter','latex');
axis tight; grid on;
xlim([0 3]); ylim([0 max([exppdf(bin_c,1) h1.Values h2.Values])]);
set(gca,'position',[0.0651 0.0729 0.8808 0.2294]);
h = legend([p1 p2 p3],{'$\mbox{Theory}$','$\mbox{CS}$','$S,i$'});
set(h,'interpreter','latex','position',[0.4233 0.2474 0.1691 0.103]);
text(0.1277,0.2,'$\mbox{(f)}$','interpreter','latex','backgroundcolor',[1 1 1]);

print(gcf,'GSM_BI.eps','-depsc','-painters');

