clear; clc; close all;

load('NUC_Phase_Pseudo_Schell_Amp_Sim_Results.mat');

figure;
set(gcf,'position',[520 420 384 384]);

U_thy_PDF = sqrt(lognrnd(log(meanI/sqrt(sigmaI^2+1)),sqrt(log(sigmaI^2+1)),1,1e6)) ...
    .*exp(1j*sigma_s*randn(1,1e6));

% subplot(321);
% imagesc(xs(1,:)*100,ys(:,1)*100,abs(U_ver)); axis image; h = colorbar;
% xlabel('$x \mbox{ (cm)}$','interpreter','latex');
% ylabel('$y \mbox{ (cm)}$','interpreter','latex');
% set(gca,'ticklabelinterpreter','latex');
% set(h,'ticklabelinterpreter','latex');
% set(gca,'position',[0.0857+0.007 0.7452 0.25 0.25]);
% text(1.3229,1.8437,'$\mbox{(a)}$','interpreter','latex','backgroundcolor',[1 1 1]);
% subplot(322);
% imagesc(xs(1,:)*100,ys(:,1)*100,angle(U_ver)); axis image; h = colorbar;
% xlabel('$x \mbox{ (cm)}$','interpreter','latex');
% ylabel('$y \mbox{ (cm)}$','interpreter','latex');
% set(gca,'ticklabelinterpreter','latex');
% set(h,'ticklabelinterpreter','latex');
% set(gca,'position',[0.612+0.007 0.7452 0.25 0.25]);
% text(1.2187,1.8437,'$\mbox{(b)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(323);
imagesc(xs(1,:)*100,ys(:,1)*100,abs(U)); axis image; h = colorbar;
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$y \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(h,'ticklabelinterpreter','latex');
set(gca,'position',[0.0857+0.007 0.3961 0.25 0.25]);
text(1.375,1.8438,'$\mbox{(a)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(324);
imagesc(xs(1,:)*100,ys(:,1)*100,angle(U)); axis image; h = colorbar;
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$y \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(h,'ticklabelinterpreter','latex');
set(gca,'position',[0.612+0.007 0.3961 0.25 0.25]);
text(1.2708,1.8438,'$\mbox{(b)}$','interpreter','latex','backgroundcolor',[1 1 1]);

subplot(3,2,5);
bin_c = diff(U_binedges)/2 + U_binedges(1:end-1);
inds = 1:10:length(bin_c);
h1 = histogram(real(U_thy_PDF),'BinEdges',U_binedges,'normalization','pdf','visible','off');
p1 = plot(bin_c,h1.Values);
hold on;
% h1 = histogram('BinEdges',U_binedges,'BinCounts',Ur_counts_ver,'normalization','pdf','visible','off');
% p2 = plot(bin_c(inds),h1.Values(inds),'o');
h2 = histogram('BinEdges',U_binedges,'BinCounts',Ur_counts,'normalization','pdf','visible','off');
p3 = plot(bin_c(inds),h2.Values(inds),'s','color',[0.47 0.69 0.19]); 
set(gca,'ticklabelinterpreter','latex');
ylabel('$p\left[\mbox{Re}\left(U\right)\right]$','interpreter','latex');
xlabel('$\mbox{Re}\left(U\right)$','interpreter','latex');
axis tight; grid on;
% ylim([0 max([normpdf(bin_c,0,1/sqrt(2)) h1.Values h2.Values])]);
set(gca,'position',[0.0911 0.0755 0.35 0.2216]);
% h = legend([p1 p2 p3],{'$\mbox{Theory}$','$\mbox{CS}$','$S,i$'});
% set(h,'interpreter','latex');
text(-0.3639,0.1102,'$\mbox{(c)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(3,2,6);
bin_c = diff(U_binedges)/2 + U_binedges(1:end-1);
inds = 1:10:length(bin_c);
h1 = histogram(imag(U_thy_PDF),'BinEdges',U_binedges,'normalization','pdf','visible','off');
p1 = plot(bin_c,h1.Values);
hold on;
% h1 = histogram('BinEdges',U_binedges,'BinCounts',Ui_counts_ver,'normalization','pdf','visible','off');
% p2 = plot(bin_c(inds),h1.Values(inds),'o');
h2 = histogram('BinEdges',U_binedges,'BinCounts',Ui_counts,'normalization','pdf','visible','off');
p3 = plot(bin_c(inds),h2.Values(inds),'s','color',[0.47 0.69 0.19]); 
set(gca,'ticklabelinterpreter','latex');
ylabel('$p\left[\mbox{Im}\left(U\right)\right]$','interpreter','latex');
xlabel('$\mbox{Im}\left(U\right)$','interpreter','latex');
axis tight; grid on;
% ylim([0 max([normpdf(bin_c,0,1/sqrt(2)) h1.Values h2.Values])]);
set(gca,'position',[0.5572 0.0755 0.35 0.2216]);
h = legend([p1 p3],{'$\mbox{Theory}$','$S,i$'});
set(h,'interpreter','latex');
set(h,'position',[0.3821 0.2712 0.2114 0.0717]);
text(-0.3639,0.1102,'$\mbox{(d)}$','interpreter','latex','backgroundcolor',[1 1 1]);

print(gcf,'NUC_fields.eps','-depsc','-painters');

%% 

figure;
set(gcf,'position',[520 420 384 384]);

subplot(331);
imagesc(xs(1,:)*100,ys(:,1)*100,real(Wx1x2_thy)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.0915 0.764 0.225 0.225]);
text(-0.9184,1.7288,'$\mbox{(a)}$','interpreter','latex','backgroundcolor',[1 1 1]);
% subplot(332);
% imagesc(xs(1,:)*100,ys(:,1)*100,real(Wx1x2_ver)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
% xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
% ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
% set(gca,'ticklabelinterpreter','latex');
% set(gca,'position',[0.3765 0.764 0.225 0.225]);
% text(-2.1721,1.7288,'$\mbox{(b)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(333);
imagesc(xs(1,:)*100,ys(:,1)*100,real(Wx1x2)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.645 0.764 0.225 0.225]);
text(-0.9091,1.7288,'$\mbox{(b)}$','interpreter','latex','backgroundcolor',[1 1 1]);

subplot(334);
imagesc(xs(1,:)*100,ys(:,1)*100,imag(Wx1x2_thy)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.0915 0.4383 0.225 0.225]);
text(1.0984,1.7288,'$\mbox{(c)}$','interpreter','latex','backgroundcolor',[1 1 1]);
% subplot(335);
% imagesc(xs(1,:)*100,ys(:,1)*100,imag(Wx1x2_ver)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
% xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
% ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
% set(gca,'ticklabelinterpreter','latex');
% set(gca,'position',[0.3765 0.4383 0.225 0.225]);
% text(1.2708,1.7288,'$\mbox{(e)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(336);
imagesc(xs(1,:)*100,ys(:,1)*100,imag(Wx1x2)); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.645 0.4383 0.225 0.225]);
text(1.2708,1.7288,'$\mbox{(d)}$','interpreter','latex','backgroundcolor',[1 1 1]);

subplot(3,3,7);
inds = 1:10:size(xs,2);
temp = diag(real(Wx1x2_thy));
plot(xs(1,:)*100,temp); 
hold on;
% temp = diag(real(Wx1x2_ver));
% plot(xs(1,inds)*100,temp(inds),'o','color',[0.93 0.69 0.13]); 
temp = diag(real(Wx1x2));
plot(xs(1,inds)*100,temp(inds),'s','color',[0.47 0.69 0.19]); 
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$\langle I\left(x,0\right)\rangle$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
axis tight; grid on;
set(gca,'position',[0.0911 0.1172 0.35 0.2216]);
text(-2.046,0.7876,'$\mbox{(e)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(3,3,9);
inds = 1:3:size(xs,2);
temp = real(Wx1x2_thy(xs==-ys));
xs_plot = xs(xs==-ys);
plot(xs_plot*100,temp); 
hold on;
% temp = real(Wx1x2_ver(xs==-ys));
% plot(xs_plot(inds)*100,temp(inds),'o','color',[0.93 0.69 0.13]); 
temp = real(Wx1x2(xs==-ys));
plot(xs_plot(inds)*100,temp(inds),'s','color',[0.47 0.69 0.19]); 
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$\mbox{Re}\left[W\left(x,0,-x,0\right)\right]$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
axis tight; grid on;
h = legend('$\mbox{Theory}$','$S,i$');
set(h,'interpreter','latex');
set(h,'position',[0.4055 0.3649 0.2114 0.0717]);
set(gca,'position',[0.5572 0.1172 0.35 0.2216]);
text(0.2925,0.7985,'$\mbox{(f)}$','interpreter','latex','backgroundcolor',[1 1 1]);
xlim([-0.5 0.5]);

print(gcf,'NUC_W.eps','-depsc','-painters');

%%
figure;
set(gcf,'position',[520 420 384 384]);
subplot(331);
imagesc(xs(1,:)*100,ys(:,1)*100,BI_thy); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.0941 0.7666 0.225 0.225]);
text(-0.5161,1.7288,'$\mbox{(a)}$','interpreter','latex','backgroundcolor',[1 1 1]);
% subplot(332);
% imagesc(xs(1,:)*100,ys(:,1)*100,BI_ver); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
% xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
% ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
% set(gca,'ticklabelinterpreter','latex');
% set(gca,'position',[0.3765 0.764 0.225 0.225]);
% text(-2.1721,1.7288,'$\mbox{(b)}$','interpreter','latex','backgroundcolor',[1 1 1]);
subplot(333);
imagesc(xs(1,:)*100,ys(:,1)*100,BI); axis image; h = colorbar; set(h,'ticklabelinterpreter','latex');
xlabel('$x_2 \mbox{ (cm)}$','interpreter','latex');
ylabel('$x_1 \mbox{ (cm)}$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
set(gca,'position',[0.685 0.7666 0.225 0.225]);
text(-0.5022,1.7288,'$\mbox{(b)}$','interpreter','latex','backgroundcolor',[1 1 1]);

subplot(3,3,4);
inds = 1:10:size(xs,2);
temp = diag(BI_thy);
plot(xs(1,:)*100,temp); 
hold on;
% temp = diag(BI_ver);
% plot(xs(1,inds)*100,temp(inds),'o','color',[0.93 0.69 0.13]); 
temp = diag(BI);
plot(xs(1,inds)*100,temp(inds),'s','color',[0.47 0.69 0.19]); 
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$B_I\left(x,0,x,0\right)$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
axis tight; grid on;
% h = legend('$\mbox{Theory}$','$\mbox{CS}$','$S,i$');
% set(h,'interpreter','latex','position',[0.3349 0.2495 0.1418 0.103]);
set(gca,'position',[0.094 0.4453 0.35 0.2216]);
text(0,0.22,'$\mbox{(c)}$','interpreter','latex','backgroundcolor',[1 1 1]);
ylim([0.2 0.3]);
subplot(3,3,6);
inds = 1:10:size(xs,2);
temp = BI_thy(xs==-ys);
xs_plot = xs(xs==-ys);
plot(xs_plot*100,temp); 
hold on;
% temp = BI_ver(xs==-ys);
% plot(xs_plot(inds)*100,temp(inds),'o','color',[0.93 0.69 0.13]); 
temp = BI(xs==-ys);
plot(xs_plot(inds)*100,temp(inds),'s','color',[0.47 0.69 0.19]); 
xlabel('$x \mbox{ (cm)}$','interpreter','latex');
ylabel('$B_I\left(x,0,-x,0\right)$','interpreter','latex');
set(gca,'ticklabelinterpreter','latex');
axis tight; grid on;
% h = legend('$\mbox{Theory}$','$\mbox{CS}$','$S,i$');
% set(h,'interpreter','latex','position',[0.2379 0.2729 0.1691 0.103]);
set(gca,'position',[0.5957 0.4453 0.35 0.2216]);
text(0,0.22,'$\mbox{(d)}$','interpreter','latex','backgroundcolor',[1 1 1]);
% xlim([-0.5 0.5]);
ylim([0.2 0.3])

subplot(3,3,[7 9]);
bin_c = diff(iI_binedges)/2 + iI_binedges(1:end-1);
inds = 1:2:length(bin_c);
p1 = plot(bin_c,lognpdf(bin_c,log(meanI/sqrt(sigmaI^2+1)),sqrt(log(sigmaI^2+1))));
hold on;
% h1 = histogram('BinEdges',iI_binedges,'BinCounts',iI_counts_ver,'normalization','pdf','visible','off');
% p2 = plot(bin_c(inds),h1.Values(inds),'o');
h2 = histogram('BinEdges',iI_binedges,'BinCounts',iI_counts,'normalization','pdf','visible','off');
p3 = plot(bin_c(inds),h2.Values(inds),'s','color',[0.47 0.69 0.19]); 
set(gca,'ticklabelinterpreter','latex');
ylabel('$p\left(I\right)$','interpreter','latex');
xlabel('$I$','interpreter','latex');
axis tight; grid on;
xlim([0 3]); ylim([0 max([lognpdf(bin_c,log(meanI/sqrt(sigmaI^2+1)),sqrt(log(sigmaI^2+1))) h2.Values])]);
set(gca,'position',[0.0938 0.1172 0.8521 0.2294]);
h = legend([p1 p3],{'$\mbox{Theory}$','$S,i$'});
set(h,'interpreter','latex');
set(h,'position',[0.7062 0.2605 0.2114 0.0717]);
text(0.5956,0.236,'$\mbox{(e)}$','interpreter','latex','backgroundcolor',[1 1 1]);

print(gcf,'NUC_BI.eps','-depsc','-painters');

